

/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission 
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE 
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License 
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite 
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably 
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 *
 *
 */


package com.funambol.blackberry.ui;

import com.funambol.util.StaticDataHelper;



import net.rim.device.api.system.Bitmap;
import net.rim.device.api.ui.Field;
import net.rim.device.api.ui.Font;
import net.rim.device.api.ui.MenuItem;
import net.rim.device.api.ui.component.BitmapField;
import net.rim.device.api.ui.component.LabelField;
import net.rim.device.api.ui.component.Menu;
import net.rim.device.api.ui.container.MainScreen;
import com.funambol.blackberry.BBVersion;
import net.rim.device.api.ui.component.RichTextField;

public class AboutScreen extends MainScreen{
    
    private BitmapField image;
    
    final public static String   IMAGE_LOGO      = "logo.png";
    
    private final MenuItem          backMenu     = new MenuItem(
                StaticDataHelper.getLanguage("menu_back"), 20000, 10)
                { public void run() {
                        onClose();
                }};
    
    /** Creates a new instance of FunSplashScreen */
    public AboutScreen() {
         
        Bitmap icon = Bitmap.getBitmapResource(IMAGE_LOGO);
        image = new BitmapField(icon, Field.FIELD_HCENTER);
        image.setSpace(5, 5);
        add(image);   
        
        LabelField clientName = new LabelField("Funambol " + BBVersion.VERSION,Field.FIELD_HCENTER);
        clientName.setFont(Font.getDefault().derive(Font.BOLD));
        add(clientName);
       
        LabelField copyright = new LabelField("Copyright (C) 2008",Field.FIELD_HCENTER);
        copyright.setFont(Font.getDefault().derive(Font.BOLD));
        add(copyright);
       
        LabelField vendor = new LabelField("Funambol Inc.",Field.FIELD_HCENTER);
        vendor.setFont(Font.getDefault().derive(Font.BOLD));
        add(vendor);
       
        LabelField rightsReserved = new LabelField("All rights reserved.",Field.FIELD_HCENTER);
        rightsReserved.setFont(Font.getDefault().derive(Font.BOLD));
        add(rightsReserved);
       
        LabelField site = new LabelField("www.funambol.com",Field.FIELD_HCENTER);
        site.setFont(Font.getDefault().derive(Font.BOLD));
        add(site);
        
      
        addLicense();
      
        
       
        
    }
    
      
    private void addLicense() {
        add(new LabelField(""));
        add(new LabelField(""));
        String license ="This program is provided AS IS, without warranty licensed under AGPLV3. The " +
                    "Program is free software; you can redistribute it and/or modify it under the " +
                    "terms of the GNU Affero General Public License version 3 as published by the Free " +
                    "Software Foundation including the additional permission set forth source code " +
                    "file header.\n\n" +
                    
                    "The interactive user interfaces in modified source and object code versions of " +
                    "this program must display Appropriate Legal Notices, as required under Section 5 " +
                    "of the GNU Affero General Public License version 3.\n\n " +
                    
                    "In accordance with Section 7(b) of the GNU Affero General Public License version 3, " +
                    "these Appropriate Legal Notices must retain the display of the \"Powered by " +
                    "Funambol\" logo. If the display of the logo is not reasonably feasible for " +
                    "technical reasons, the Appropriate Legal Notices must display the words \"Powered " +
                    "by Funambol\". Funambol is a trademark of Funambol, Inc.";
        RichTextField rtf = new RichTextField(license,RichTextField.TEXT_ALIGN_HCENTER);
        rtf.setFont(Font.getDefault().derive(Font.PLAIN));
        add(rtf);
           
    }
    
    public void makeMenu(Menu menu, int instance)
    {
     
        menu.add(backMenu);
    }
    
    

}
