/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission 
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE 
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License 
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite 
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably 
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 *
 *
 */
package com.funambol.blackberry.ui;

import com.funambol.util.StaticDataHelper;



import net.rim.device.api.system.Bitmap;
import net.rim.device.api.ui.Field;
import net.rim.device.api.ui.Font;
import net.rim.device.api.ui.MenuItem;
import net.rim.device.api.ui.component.BitmapField;
import net.rim.device.api.ui.component.LabelField;
import net.rim.device.api.ui.component.Menu;
import net.rim.device.api.ui.container.MainScreen;
import com.funambol.blackberry.BBVersion;
import com.funambol.blackberry.SyncClient;
import net.rim.device.api.ui.component.RichTextField;

public class QuestionScreen extends MainScreen {

    public static int NOT_ANSWERED = -1;
    public static int CONFIRM = 0;
    public static int CANCEL = 1;
    public static int response = NOT_ANSWERED;
    public static Object lock = new Object();
    private final MenuItem cancelMenu = new MenuItem(
            StaticDataHelper.getLanguage("menu_cancel"), 20000, 10) {

        public void run() {
            System.out.println("cancel has been selected");
            synchronized (lock) {
                response = CANCEL;
                System.out.println("notifying");
                lock.notify();

                onClose();
            }
        }
    };
    private final MenuItem continueMenu = new MenuItem(
            StaticDataHelper.getLanguage("menu_continue"), 20000, 10) {

        public void run() {
            System.out.println("continue has been selected");
            synchronized (lock) {
                response = CONFIRM;
                System.out.println("notifying");
                lock.notify();

                onClose();
            }
        }
    };

    /** Creates a new instance of FunSplashScreen */
    public QuestionScreen(String apn) {

        String message = StaticDataHelper.getLanguage("message_question-1") + " " + 
               apn + " " + StaticDataHelper.getLanguage("message_question-2"); 
                 
        LabelField question = new LabelField(message, Field.FIELD_HCENTER);
        question.setFont(Font.getDefault().derive(Font.BOLD));
        add(question);
        System.out.println("created question screen");


    }

    public void makeMenu(Menu menu, int instance) {
        menu.add(cancelMenu);
        menu.add(continueMenu);
    }
  
}
