/*
 * Funambol is a mobile platform developed by Funambol, Inc.
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

package com.funambol.util;


import java.io.IOException;
import java.io.InputStream;
import java.util.Hashtable;

import net.rim.device.api.system.ApplicationDescriptor;
import net.rim.device.api.system.ApplicationManager;
import net.rim.device.api.system.EventLogger;
import net.rim.device.api.ui.Font;

import com.funambol.blackberry.Configuration;

/**
 * Supports general using, language dictionary access, logging. Statics data and
 * static methods
 */
public class StaticDataHelper
{
    private static boolean      debug                       = true;
    private static String       ClientVersion;
    // -----------------------------------------------------------------
    // Constants
    private static int          pollingPIMIntervalDefault       = 0;
    private static boolean      enablePollingPIMDefault         = false;
    private static boolean      syncCalendarDefault             = false;
    private static boolean      syncContactDefault              = false;
    private static boolean      syncNoteDefault                 = false;
    private static boolean      syncTaskDefault                 = false;

    private static boolean      encodeDefault                   = false;
    
    private static int          syncTypeDefault                 = 0; 
    
    private static int          logLevelDefault                 = 0;
    
    private static String       serverUriDefault                = null;
    private static String       encryptDefault                  = null;

    private static String       usernameDefault                 = null;
    private static String       passwordDefault                 = null;

    private static String       calendarSourceUriDefault        = null;
    private static String       contactSourceUriDefault         = null;
    private static String       noteSourceUriDefault            = null;
    private static String       taskSourceUriDefault            = null;

        private static int                      rangePastDefault                = 0;
        private static int                      rangeFutureDefault              = 0;
    
    private static String       operatingSystem                 = null;

    final private static String     KEY_ENABLE_POLLING_PIM_DEFAULT      = "default_enable-polling-pim";
    final private static String     KEY_POLLING_PIM_INTERVAL_DEFAULT    = "default_polling-pim-interval";

    final private static String     KEY_SYNC_CALENDAR                   = "default_sync-calendar";
    final private static String     KEY_SYNC_CONTACT                    = "default_sync-contact";
    final private static String     KEY_SYNC_NOTE                       = "default_sync-note";
    final private static String     KEY_SYNC_TASK                       = "default_sync-task";

    final private static String     KEY_ENCODE                          = "default_encode";    

    final private static String     KEY_HOMEPAGE                        = "default_server-uri";
    final private static String     KEY_ENCRYPTION_DEFAULT              = "default_encryption-type";

    private final static String     KEY_USERNAME                        = "default_username";
    private final static String     KEY_PASSWORD                        = "default_password";
    
    final private static String     KEY_CALENDAR_SOURCE_URI             = "default_calendar-source-uri";
    final private static String     KEY_CONTACT_SOURCE_URI              = "default_contact-source-uri";
    final private static String     KEY_NOTE_SOURCE_URI                 = "default_note-source-uri";
    final private static String     KEY_TASK_SOURCE_URI                 = "default_task-source-uri";
    
    final private static String     KEY_SYNC_TYPE                       = "default_sync-type";
    
    final private static String     KEY_RANGE_PAST_DEFAULT              = "default_range-past";
    final private static String     KEY_RANGE_FUTURE_DEFAULT            = "default_range-future";
    
    final private static String     KEY_LOG_LEVEL                       = "default_log-level";
   
  
    final public static int         FONT_SIZE         = 14;
    final public static int         FONT_STYLE        = Font.PLAIN;
    final public static int         TITLE_FONT_SIZE   = 16;
    final public static int         TITLE_FONT_STYLE  = Font.BOLD;
    final public static int         TITLE_PADDING     = 5;

    final public static int         SYNC_TYPE_TWO_WAY = 0;
    final public static int         SYNC_TYPE_ONE_WAY_TO_SERVER = 1;
    final public static int         SYNC_TYPE_ONE_WAY_TO_CLIENT = 2;
    final public static int         SYNC_TYPE_REFRESH_TO_SERVER = 3;
    final public static int         SYNC_TYPE_REFRESH_TO_CLIENT = 4;

    // ----------------------------------------------------------------- Private
    // data
    final private static ErrorLog   errors                          = new ErrorLog();
    private static Hashtable        languageHash                    = new Hashtable();
    final private static String     XML_LANGUAGE_CONTENT_TAG        = "en_us";
    // ----------------------------------------------------------------- Public
    // methods
    final public static String      XML_LANGUAGE                    = "/xml/language.xml";    

    public static String getOS()
    {
        return operatingSystem;
    }
    
    public static String getPasswordDefault()
    {
        return passwordDefault;
    }
    
    public static String getUserDefault()
    {
        return usernameDefault;
    }
    
    public static int getSyncTypeDefault()
    {
        return syncTypeDefault;
    }
    
    public static int getLogLevelDefault()
    {
        return logLevelDefault;
    }
    
    public static boolean isEncode()
    {
        return encodeDefault;
    }

    public static boolean getSyncCalendarDefault()
    {
        return syncCalendarDefault;
    }
    
    public static boolean getSyncContactDefault()
    {
        return syncContactDefault;
    }
    
    public static boolean getSyncNoteDefault()
    {
        return syncNoteDefault;
    }
    
    public static boolean getSyncTaskDefault()
    {
        return syncTaskDefault;
    }

    public static String getServerUriDefault()
    {
        return serverUriDefault;
    }

    public static String getCalendarSourceUriDefault()
    {
        return calendarSourceUriDefault;
    }
    
    public static String getContactSourceUriDefault()
    {
        return contactSourceUriDefault;
    }
    
    public static String getNoteSourceUriDefault()
    {
        return noteSourceUriDefault;
    }
    
    public static String getTaskSourceUriDefault()
    {
        return taskSourceUriDefault;
    }
    
    public static boolean getEnablePollingPIMDefault()
    {
        return enablePollingPIMDefault;
    }
    
    public static int getPollingPIMIntervalDefault()
    {
        return pollingPIMIntervalDefault;
    }
    
    public static int getRangePastDefault()
    {
        return rangePastDefault;
    }
    
    public static int getRangeFutureDefault()
    {
        return rangeFutureDefault;
    }
    
    public static String getEncryptDefault()
    {
        return encryptDefault;
    }

    public static ErrorLog getErrors()
    {
        return errors;
    }
    
    /**
     * Make a String by value of <i>tag</i>.
     * @param key key to find
     * @return key value
     */
    public static String getLanguage(String key)
    {
        //StaticDataHelper.info("There are ["+StaticDataHelper.languageHash.size()+"] key-value pairs");
        StaticDataHelper.debug("Getting value of key ["+key+"]");

        Object valueFromHash = null;
        valueFromHash = StaticDataHelper.languageHash.get(key);
        if (valueFromHash != null)
        {
            return (String) valueFromHash;
        }
        return null;
    }
    
    public static void init(Class c, String languagefile) throws Exception
    {
        StaticDataHelper.loadLanguage(c,languagefile);
        StaticDataHelper.loadDefaultValue();
        StaticDataHelper.setOS();
    }
       
    /**
     * Load default properties form jad file
     */
    private static void loadDefaultValue() throws Exception
    {
        String enableContact = null;
        String enableCalendar = null;
        String enableTask = null;
        String enableNote = null;
        String enablePollingPIM = null;
        String pollingPIMInterval = null;
        String rangePast = null;
        String rangeFuture = null;
        String encode = null;
        String syncType = null;
        String logLevel = null;
        
        serverUriDefault                    = getLanguage(KEY_HOMEPAGE);
        usernameDefault                     = getLanguage(KEY_USERNAME);
        passwordDefault                     = getLanguage(KEY_PASSWORD);
        contactSourceUriDefault             = getLanguage(KEY_CONTACT_SOURCE_URI);
        calendarSourceUriDefault            = getLanguage(KEY_CALENDAR_SOURCE_URI);
        taskSourceUriDefault                = getLanguage(KEY_TASK_SOURCE_URI);
        noteSourceUriDefault                = getLanguage(KEY_NOTE_SOURCE_URI);
        enableContact                       = getLanguage(KEY_SYNC_CONTACT);
        enableCalendar                      = getLanguage(KEY_SYNC_CALENDAR);
        enableTask                          = getLanguage(KEY_SYNC_TASK);
        enableNote                          = getLanguage(KEY_SYNC_NOTE);
        enablePollingPIM                    = getLanguage(KEY_ENABLE_POLLING_PIM_DEFAULT);
        pollingPIMInterval                  = getLanguage(KEY_POLLING_PIM_INTERVAL_DEFAULT);
        rangePast                           = getLanguage(KEY_RANGE_PAST_DEFAULT);
        rangeFuture                         = getLanguage(KEY_RANGE_FUTURE_DEFAULT);
        encode                              = getLanguage(KEY_ENCODE);
        syncType                            = getLanguage(KEY_SYNC_TYPE);
        logLevel                            = getLanguage(KEY_LOG_LEVEL);
        encryptDefault                      = getLanguage(KEY_ENCRYPTION_DEFAULT);
        
        if (serverUriDefault == null)
        {
            serverUriDefault = "";
        }
        if (usernameDefault == null)
        {
            usernameDefault = "";
        }
        if (passwordDefault == null)
        {
            passwordDefault = "";
        }
        if (contactSourceUriDefault == null)
        {
            contactSourceUriDefault = "";
        }
        if (calendarSourceUriDefault == null)
        {
            calendarSourceUriDefault = "";
        }
        if (taskSourceUriDefault == null)
        {
            taskSourceUriDefault = "";
        }
        if (noteSourceUriDefault == null)
        {
            noteSourceUriDefault = "";
        }

        if (syncType == null || !(syncType.length() > 0))
        {
                syncTypeDefault = 0;
        }
        else
        {
                try {
                        syncTypeDefault = Integer.parseInt(syncType);
                }
            catch (final NumberFormatException e)
            {
                final String msg = "StaticDataHelper.loadDefaultValue(): invalid default log level default";
                StaticDataHelper.log(msg);
                throw new Exception(msg);
            }
        }

        if (logLevel == null || !(logLevel.length() > 0))
        {
                logLevelDefault = Log.TRACE;
        }
        else
        {
                try {
                        logLevelDefault = Integer.parseInt(logLevel);
                }
            catch (final NumberFormatException e)
            {
                final String msg = "StaticDataHelper.loadDefaultValue(): invalid log level default";
                StaticDataHelper.log(msg);
                throw new Exception(msg);
            }
        }

        if (pollingPIMInterval == null || !(pollingPIMInterval.length() > 0))
        {
                pollingPIMIntervalDefault = 0;
        }
        else
        {
            try
            {
                pollingPIMIntervalDefault = Integer.parseInt(pollingPIMInterval);
            }
            catch (final NumberFormatException e)
            {
                final String msg = "StaticDataHelper.loadDefaultValue(): invalid default pim polling interval";
                StaticDataHelper.log(msg);
                throw new Exception(msg);
            }
        }
        
        if (rangePast == null || !(rangePast.length() > 0))
        {
                rangePastDefault = 1;
        }
        else
        {
                try 
                {
                        rangePastDefault = Integer.parseInt(rangePast); 
                }
                catch (NumberFormatException e)
                {
                        final String msg = "StaticDataHelper.loadDefaultValue(): invalid default range past default";
                        StaticDataHelper.error(msg);
                        throw new Exception(msg);
                }
        }
        
        if (rangeFuture == null || !(rangeFuture.length() > 0))
        {
                rangeFutureDefault = 1;
        }
        else
        {
                try 
                {
                        rangeFutureDefault = Integer.parseInt(rangeFuture);     
                }
                catch (NumberFormatException e)
                {
                        final String msg = "StaticDataHelper.loadDefaultValue(): invalid default range future default";
                        StaticDataHelper.error(msg);
                        throw new Exception(msg);
                }
        }

        if (encryptDefault == null)
        {
            encryptDefault = "none";
        }
        if ("true".equals(enableContact))
        {
            syncContactDefault = true;
        }
        if ("true".equals(enableCalendar))
        {
            syncCalendarDefault = true;
        }
        if ("true".equals(enableTask))
        {
            syncTaskDefault = true;
        }
        if ("true".equals(enableNote))
        {
            syncNoteDefault = true;
        }
        if ("true".equals(enablePollingPIM))
        {
            enablePollingPIMDefault = true;
        }
        if ("true".equals(encode))
        {
            encodeDefault = true;
        }
    }
    
    /**
     * load xml language file
     */
    private static void loadLanguage(Class c, String languagefile) throws Exception
    {
        StaticDataHelper.info("Reading language file ["+languagefile+"]");
        try
        {
            String language = read(c.getResourceAsStream(languagefile));
            SimpleXMLParser parser = new SimpleXMLParser();
            StaticDataHelper.languageHash = parser.parseData(StaticDataHelper.XML_LANGUAGE_CONTENT_TAG,language);
            language = null;
            parser = null;
            StaticDataHelper.info("Reading language file ["+languagefile+"] successfully");
        }
        catch (final Throwable e)
        {
            final String msg = "Error: load " + languagefile + " file: " + e.getMessage();
            StaticDataHelper.log(msg);
            throw new Exception("Error reading language definition file.");
        }
    }
    
    private static void setOS()
    {
        final ApplicationDescriptor[] appDes = ApplicationManager.getApplicationManager()
                .getVisibleApplications();
        String version = "";
        for (int i = appDes.length - 1; i >= 0; --i)
        {
            if (appDes[i].getModuleName().equals("net_rim_bb_ribbon_app"))
            {
                version = appDes[i].getVersion();
                break;
            }
        }
        operatingSystem = version;
    }

    public static void setClientVersion(String ver)
    {
        ClientVersion = ver;
    }
    /**
     * Logs a string to standard output and to the device's event logger (press
     * ALT + lglg on the device to see the event log)
     * @param msg the string to be logged
     */
    private static void log(String msg)
    {
        if (debug)
        {
            System.out.println(msg);
        }
        
        // com.funambol.syncclient.util.StaticDataHelper
        final long guid = 0x948b87e2ee064ebeL;
        try
        {
            EventLogger.register(guid, "Blackberry-Sync " + ClientVersion, EventLogger.VIEWER_STRING);
        }
        catch (final Throwable t)
        {
            System.out.println(">>> Exception by registering the event logger:\n"
                    + ">>> Error message: " + t.getMessage() + "\n" + ">>> Short description: "
                    + t.toString() + "\n");
            t.printStackTrace();
        }
        
        try
        {
            if (msg != null)
            {
                EventLogger.logEvent(guid, msg.getBytes());
            }
            else
            {
                System.out.println(">>> [DEBUG] String msg is " + msg);
            }
        }
        catch (final Throwable tt)
        {
            System.out.println(">>> Exception by registering the event logger:\n"
                    + ">>> Error message: " + tt.getMessage() + "\n" + ">>> Short description: "
                    + tt.toString() + "\n");
            tt.printStackTrace();
        }
    }
    
    /**
     * Error logging.  Errors are also added to the ErrorLog class
     * 
     * @param message	The message to log
     */
    public static void error(String message)
    {
        StaticDataHelper.log("[ERROR] " + message);
        if (!message.equals(StaticDataHelper.getLanguage("message_generic-error")))
        {
            StaticDataHelper.errors.addError(message);
        }
    }

    /**
     * Info level logging
     * 
     * @param message	The message to log
     */
    public static void info(String message)
    {
        if (Configuration.logLevel >= Log.INFO)
        {
            StaticDataHelper.log("[INFO] " + message);
        }
    }
    
    /**
     * Debug logging
     * 
     * @param message	The message to log
     */
    public static void debug(String message)
    {
        if (Configuration.logLevel >= Log.DEBUG)
        {
            StaticDataHelper.log("[DEBUG] " + message);
        }
    }
    
    /**
     * Trace logging
     * 
     * @param message	The message to log
     */
    public static void trace(String message)
    {
        if (Configuration.logLevel >= Log.TRACE)
        {
            StaticDataHelper.log("[TRACE] " + message);
        }
    }
    
    /**
     * Reads the content of the given input stream.
     * 
     * @param is the input stream
     */
    public static String read(InputStream is) throws IOException
    {
        final StringBuffer sb = new StringBuffer();
        try
        {
            final byte[] buf = new byte[1024];
            int nbyte = -1;
            while ((nbyte = is.read(buf)) >= 0)
            {
                sb.append(new String(buf, 0, nbyte));
            }
        }
        finally
        {
            is.close();
        }
        return sb.toString();
    }
}
